CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

SetFitPoint Method (ActiveX)

2023-1-4 02:15| 发布者: admin| 查看: 388| 评论: 0|来自: AutoCAD

摘要: 设置样条曲线的拟合点。

设置样条曲线的拟合点。

支持的平台:仅窗口

签名

工 务 局:

object.SetFitPoint Index, Value
对象

类型:样条

此方法适用的对象。

指数

访问:仅输入

类型:

要设置的拟合点的索引位置。第一个拟合点是索引 0。

价值

访问:仅输入

类型:变体(双精度的三元素数组)

3D WCS 坐标指定给定索引位置处样条的拟合点。

返回值(RetVal)

无返回值。

言论

没有额外的评论。

例子

工 务 局:

Sub Example_SetFitPoint()
    ' This example creates a spline object in model space.
    ' It then finds the coordinates of the first fit point
    ' and changes that value.

    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    ZoomAll
    
    ' Display the coordinates of the first fit point
    Dim fitPoint As Variant
    fitPoint = splineObj.GetFitPoint(0)
    MsgBox "Fit point 1 is at " & fitPoint(0) & ", " & fitPoint(1) & ", " & fitPoint(2), , "SetFitPoint Example"
    
    ' Change the coordinates of the first fit point
    fitPoint(0) = 0: fitPoint(1) = 3: fitPoint(2) = 0
    splineObj.SetFitPoint 0, fitPoint
    splineObj.Update
    MsgBox "Fit point 1 is now at " & fitPoint(0) & ", " & fitPoint(1) & ", " & fitPoint(2), , "SetFitPoint Example"
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_SetFitPoint()
    ;; This example creates a spline object in model space.
    ;; It then finds the coordinates of the first fit point
    ;; and changes that value.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 0
                                     5 5 0
				                                 10 0 0
				                                )
    )
    
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))
    (vla-ZoomAll acadObj)
    
    ;; Display the coordinates of the first fit point
    (setq fitPoint (vlax-variant-value (vla-GetFitPoint splineObj 0)))
    (alert (strcat "Fit point 1 is at " (rtos (vlax-safearray-get-element fitPoint 0) 2) ", "
                                        (rtos (vlax-safearray-get-element fitPoint 1) 2) ", "
                                        (rtos (vlax-safearray-get-element fitPoint 2) 2)))
    
    ;; Change the coordinates of the first fit point
    (setq fitPoint (vlax-3d-point 0 3 0))
    (vla-SetFitPoint splineObj 0 fitPoint)
    (vla-Update splineObj)
    (setq fitPoint (vlax-variant-value fitPoint))
    (alert (strcat "Fit point 1 is now at " (rtos (vlax-safearray-get-element fitPoint 0) 2) ", "
                                            (rtos (vlax-safearray-get-element fitPoint 1) 2) ", "
                                            (rtos (vlax-safearray-get-element fitPoint 2) 2)))
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-12 05:38

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部